import {
  JupyterFrontEnd,
  JupyterFrontEndPlugin
} from '@jupyterlab/application';
import {
  ICommandPalette,
  MainAreaWidget
} from '@jupyterlab/apputils';
import { TrainingIcon } from './images'; 
import { ISettingRegistry } from '@jupyterlab/settingregistry';
import { LabIcon  } from '@jupyterlab/ui-components';
//import { requestAPI } from './handler';

import { ILauncher} from '@jupyterlab/launcher';
import {TrainingWidget} from "./widget"


const plugin: JupyterFrontEndPlugin<void> = {
  id: 'jupyterlab-training:plugin',
  autoStart: true,
  optional: [ISettingRegistry,  ILauncher, ICommandPalette],
  activate: (app: JupyterFrontEnd, settingRegistry: ISettingRegistry | null, launcher:ILauncher,palette: ICommandPalette) => {
   // console.log('JupyterLab extension jupyterlab-data-pool is activated!');

    if (settingRegistry) {
      // settingRegistry
      //   .load(plugin.id)
      //   .then(settings => {
      //     console.log('jupyterlab-data-pool settings loaded:', settings.composite);
      //   })
      //   .catch(reason => {
      //     console.error('Failed to load settings for jupyterlab-data-pool.', reason);
      //   });
    }

    // requestAPI<any>('get_example')
    //   .then(data => {
    //     console.log(data);
    //   })
    //   .catch(reason => {
    //     console.error(
    //       `The jupyterlab-data-pool server extension appears to be missing.\n${reason}`
    //     );
    //   });
      const webDavIcon = new LabIcon({ name: 'ui-components:training-icon', svgstr: TrainingIcon});
    
      const label = "Training"
      const content = new TrainingWidget(label);
      const widget = new MainAreaWidget({content});
      widget.id = 'jupyterlab-training:plugin';
      widget.title.label = label
      widget.title.closable = true;
      widget.title.icon = webDavIcon

    
      const command: string = 'jupyterlab-training:open'   
      app.commands.addCommand(command, {
        label: label,
        icon: webDavIcon,
        execute: () => {
          if (!widget.isAttached) {
            app.shell.add(widget, 'main');
          }
          content.update();
          app.shell.activateById(widget.id);
        }
      });
      const launcher_item : ILauncher.IItemOptions = {
        command: command,
        args: {
          url: "#",
          newBrowserTab: true,
          title: 'Training',
          id: 'training'
        },
     category: 'Other',
        rank: 2,
    };
    launcher.add(launcher_item)
    
    palette.addItem({ command, category: 'Share' });
  
  
    
    
    
  }
};

export default plugin;
